$!++
$! DCC_IOCTL.COM - find out what TCP/IP implementation is installed
$!			(recognizes currently only UCX and TCP/IP V5)
$!		and then compile VMS__IOCTL.C using CC_PYTHON.COM
$!
$! Parameters:
$!	P1 =
$!	    "OLBFILESPEC|t_olbnam|l_version"
$!			- return .OLB filespec in BLDRUN_GT_OLBFILESPEC
$!	    "COMPILE|t_olbnam|l_version"
$!		T_OLBNAM - .OLB name (full filespec in a symbol - see below)
$!
$!	P2 = T_MODULE	- module name (VMS_SYS)
$!	P3 = "t_olb|t_dbg|t_thread|t_ver_a|t_ver_v"
$!		T_OLB	 - do/don't put .OBJ in .OLB
$!		T_DBG	 - A]lways, N]ever, C]config-depended CC/DEBUG
$!		T_THREAD - WITH_THREAD
$!		T_VER_A	 - OpenVMS Alpha version
$!		T_VER_V	 - OpenVMS VAX version
$!	P4 = T_INCL	 - /INCLUDE=
$!
$!	Symbols supplied by caller BLDRUN.COM:
$!		BLDRUN_T_MODULE_COUNTER		- diagnostic output
$!		BLDRUN_GT_OLBFILESPEC		- reused after "OLBFILESPEC"
$!
$! Returns:
$!	BLDRUN_GT_OLBFILESPEC if P1="OLBFILESPEC"
$!--
$! ----------------------------------------------------------------------------
$ _PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ _NAME      = F$PARSE(_PROCEDURE,,,"NAME")
$ T_OPERATION = F$ELEMENT(0,"|",P1)
$! ----------------------------------------------------------------------------
$ if (T_OPERATION .eqs. "OLBFILESPEC")
$ then
$   goto CALL_CC_PYTHON		! just pass control to CC_PYTHON
$ endif
$ ! -- else			! find out which procedure to use
$! ----------------------------------------
$ if (F$SEARCH("SYS$COMMON:[SYSHLP.EXAMPLES.UCX]UCX$IOCTL_ROUTINE.C") -
	.nes. "")
$ then
$   ! -- found 'old' impementation
$   write SYS$ERROR "%''_NAME'-I-TCPVER, recognized UCX"
$   define TCPIP_IOCTL_ROUTINE -
	SYS$COMMON:[SYSHLP.EXAMPLES.UCX]UCX$IOCTL_ROUTINE.C
$ else
$   if (F$SEARCH("SYS$COMMON:[SYSHLP.EXAMPLES.TCPIP]TCPIP$IOCTL_ROUTINE.C") -
	.nes. "")
$   then
$     ! -- found new version (TCP/IP V5)
$     write SYS$ERROR "%''_NAME'-I-TCPVER, recognized TCP/IP"
$     define TCPIP_IOCTL_ROUTINE -
	SYS$COMMON:[SYSHLP.EXAMPLES.TCPIP]TCPIP$IOCTL_ROUTINE.C
$   else
$     ! -- not recognized
$     write SYS$ERROR "%''_NAME'-F-TCPNOTFND, did not recognize TCP/IP version"
$     write SYS$ERROR " (cannot compile VMS__IOCTL.C)"
$     set DEFAULT '_DEFAULT'
$     exit %X2C
$   endif
$ endif
$! ----------------------------------------------------------------------------
$CALL_CC_PYTHON:
$ set NOON
$ @ PYTHON_TOOLS:CC_PYTHON -
    "''P1'" "''P2'" "''P3'" "''P4'" "''P5'" "''P6'" "''P7'" "''P8'" 
$ if (T_OPERATION .nes. "OLBFILESPEC")
$ then
$   deassign TCPIP_IOCTL_ROUTINE
$ endif
$! ----------------------------------------------------------------------------
$PROC_EXIT:
$ exit 1 ! DCC_IOCTL.COM
