$!++
$! CC_PYTHON.COM - compile a module + put .OBJ in .OLB (or .O in .A)
$!
$! Parameters:
$!	P1 =
$!	    "OLBFILESPEC|t_olbnam|l_version"
$!			- return .OLB filespec in BLDRUN_GT_OLBFILESPEC
$!	    "COMPILE|t_olbnam|l_version"
$!		T_OLBNAM - .OLB name (full filespec in a symbol - see below)
$!
$!	P2 = T_MODULE	- module name (VMS_SYS)
$!	P3 = "t_olb|t_dbg|t_thread|t_envcomp|t_ver_a|t_ver_v"
$!		T_OLB	  - do/don't put .OBJ in .OLB
$!		T_DBG	  - A]lways, N]ever, C]config-depended CC/DEBUG
$!		T_THREAD  - WITH_THREAD
$!		T_ENVCOMP - Environment=Compiler
$!		T_VER_A	  - OpenVMS Alpha version
$!		T_VER_V	  - OpenVMS VAX version
$!	P4 = T_INCL	  - /INCLUDE=
$!
$!	Symbols supplied by caller BLDRUN.COM:
$!		BLDRUN_T_MODULE_COUNTER		- diagnostic output
$!		BLDRUN_GT_OLBFILESPEC		- reused after "OLBFILESPEC"
$!
$! Returns:
$!	BLDRUN_GT_OLBFILESPEC if P1="OLBFILESPEC"
$!--
$! ----------------------------------------------------------------------------
$ _PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ _NAME      = F$PARSE(_PROCEDURE,,,"NAME")
$!
$ _DEFAULT = F$ENVIRONMENT("DEFAULT")
$! ----------------------------------------------------------------------------
$ T_OPERATION   = F$ELEMENT(0,"|",P1)
$ T_OLBNAM      = F$ELEMENT(1,"|",P1)
$ L_PAR_VERSION = F$ELEMENT(2,"|",P1) ! parameter handling
$! ----------------------------------------------------------------------------
$ if (F$TRNLNM("PYTHON_CFG_ENVIRONMENT") .eqs. "DCL")
$ then
$   _CFG_ENV_NAM = "D"	! DCL
$   _OBJTYP = ".OBJ"
$   _OLBTYP = ".OLB"
$ else
$   _CFG_ENV_NAM = "P"	! assume POSIX
$   _OBJTYP = ".O"
$   _OLBTYP = ".A"
$ endif ! (F$TRNLNM("PYTHON_CFG_ENVIRONMENT"))
$! ----------------------------------------------------------------------------
$ if (T_OPERATION .eqs. "OLBFILESPEC")
$ then
$   BLDRUN_GT_OLBFILESPEC == "?"
$   set DEFAULT PYTHON_OLB:
$   ! --------------------
$   ! -- build filename
$   if (F$TRNLNM("PYTHON_CFG_DEBUG"))
$   then
$     _CFG_DBG_NAM = "D"
$   else
$     _CFG_DBG_NAM = "0"
$   endif ! (F$TRNLNM("PYTHON_CFG_DEBUG"))
$   !
$   if (F$TRNLNM("PYTHON_CFG_THREADS"))
$   then
$     _CFG_THR_NAM = "T"
$   else
$     _CFG_THR_NAM = "0"
$   endif
$   !
$   _OLBFIL = T_OLBNAM + "_" + _CFG_ENV_NAM + _CFG_DBG_NAM + _CFG_THR_NAM
$   ! --------------------
$   BLDRUN_GT_OLBFILESPEC == F$PARSE(_OLBFIL,"PYTHON_OLB:''_OLBTYP'")
$   ! --------------------
$   set DEFAULT '_DEFAULT'
$   exit 1
$ endif ! (T_OPERATION .eqs. "OLBFILESPEC")
$! ----------------------------------------------------------------------------
$ if (T_OPERATION .nes. "COMPILE")
$ then
$     write SYS$ERROR "%''_NAME'-F-BADP1, invalid value for parameter 1"
$     set DEFAULT '_DEFAULT'
$     exit %X2C
$ endif
$! ----------------------------------------------------------------------------
$! T_OPERATION == "COMPILE|module"
$!
$ T_MODULE = P2
$ T_OLB    = F$ELEMENT(0,"|",P3)
$ T_DBG    = F$ELEMENT(1,"|",P3)
$ T_THREAD = F$ELEMENT(2,"|",P3)
$ T_VER_A  = F$ELEMENT(3,"|",P3)
$ T_VER_V  = F$ELEMENT(4,"|",P3)
$! ----------------------------------------------------------------------------
$ if (F$EXTRACT (0,1,T_OLBNAM .eqs. "@"))
$ then
$   X_NEWOLBFIL = "TRUE"		! create a new object library
$   T_OLBNAM    = F$EXTRACT(1,F$LENGTH(T_OLBNAM),T_OLBNAM) ! remove "@"
$ else
$   X_NEWOLBFIL = "FALSE
$ endif
$! ----------------------------------------------------------------------------
$! write SYS$OUTPUT F$FAO("!79*-")
$ _DEFAULT = F$ENVIRONMENT("DEFAULT")
$ on ERROR then $ goto PROC_EXIT
$!
$ _DEVICE    = F$PARSE(_PROCEDURE,,,"DEVICE")
$ _DIRECTORY = F$PARSE(_PROCEDURE,,,"DIRECTORY")
$ _PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ _NAME      = F$PARSE(_PROCEDURE,,,"NAME")
$! ----------------------------------------------------------------------------
$ _CFG_TXT = ""
$! ----------------------------------------
$ if (T_DBG .eqs. "A")		! A]lways compile with /DEBUG
$ then
$   _CFG_DEBUG   = 1
$   _CFG_TXT     = _CFG_TXT + "DEBUG,"
$   _CFG_DBG_NAM = "D"
$ else
$   if (T_DBG .eqs. "N")	! N]ever compile with /DEBUG
$   then
$     _CFG_DEBUG   = 1
$     _CFG_TXT     = _CFG_TXT + "DEBUG,"
$     _CFG_DBG_NAM = "D"
$   else			! everything else is assumed: C]onfig-depended
$     if (F$TRNLNM("PYTHON_CFG_DEBUG"))
$     then
$       _CFG_DEBUG   = 1
$       _CFG_TXT     = _CFG_TXT + "DEBUG,"
$       _CFG_DBG_NAM = "D"
$     else
$       _CFG_DEBUG   = 0
$       _CFG_TXT     = _CFG_TXT + "noDEBUG,"
$       _CFG_DBG_NAM = "0"
$     endif ! (F$TRNLNM("PYTHON_CFG_DEBUG"))
$   endif ! (T_DBG .eqs. "N")
$ endif ! (T_DBG .eqs. "A")
$! ----------------------------------------------------------------------------
$ if (F$TRNLNM("PYTHON_CFG_THREADS"))
$ then
$   _CFG_THREADS = 1
$   _CFG_TXT     = _CFG_TXT + "THREADS"
$   _CFG_THR_NAM = "T"
$ else
$   _CFG_THREADS = 0
$   _CFG_TXT     = _CFG_TXT + "noTHREADS"
$   _CFG_THR_NAM = "0"
$ endif
$!
$ if (T_THREAD .eqs. "T")
$ then
$   if (.not. _CFG_THREADS)
$   then
$     write SYS$ERROR F$FAO("%!AS-I-NOTCOMP, module!AS: !AS", _NAME, -
	    BLDRUN_T_MODULE_COUNTER, T_MODULE)
$	    ! ^^ supplied by BLDRUN.COM    ^^ P2
$     write SYS$ERROR "-''_NAME'-I-NOTHCFG, thread support not configured"
$     set DEFAULT '_DEFAULT'
$     exit 1
$   endif
$ endif
$! ----------------------------------------------------------------------------
$!+
$! check if configured environment + module environment matches
$!-
$ T_ENV = F$ELEMENT(0,"=",T_ENVCOMP)
$!            (valid in both envs)   (valid in current env)
$ if (.not. ( (T_ENV .eqs. "B") .or. (T_ENV .eqs. _CFG_ENV_NAM) ))
$ then
$     write SYS$ERROR F$FAO("%!AS-I-NOTCOMP, module!AS: !AS", _NAME, -
	    BLDRUN_T_MODULE_COUNTER, T_MODULE)
$	    ! ^^ supplied by BLDRUN.COM    ^^ P2
$     write SYS$ERROR "-''_NAME'-I-ENVMISM, environment mismatch - CFG=''_CFG_ENV_NAM', MODULE=''T_ENV'"
$     set DEFAULT '_DEFAULT'
$     exit 1
$ endif
$ T_COMP = F$ELEMENT(1,"=",T_ENVCOMP)
$! ----------------------------------------------------------------------------
$!+
$! select compiler for module depending on environment and configuration
$!-
$ if (T_ENV .eqs. "D")		! DCL-only
$ then
$   T_COMP = "D"		! always use DCL C in DCL environment
$ else
$   if (T_ENV .eqs. "B")	! DCL/POSIX
$   then
$     ! check current environment
$     if (_CFG_ENV_NAM .eqs. "D") ! DCL
$     then
$	T_COMP = "D"		! always use DCL C in DCL environment
$     else ! _CFG_ENV_NAM .eqs. "P"
$	if (T_COMP .eqs. "D")
$       then
$	  T_COMP = "D"		! use DCL C although in POSIX environment
$       else ! T_COMP= E,P
$         T_COMP = "P"		! use POSIX C in POSIX environment
$       endif
$     endif
$   else ! T_ENV .eqs. "P"	! POSIX-ONLY
$     if (T_COMP .eqs. "E")
$     then
$       T_COMP = "P"		! default for POSIX environment is POSIX C
$     endif
$   endif
$ endif
$! ----------------------------------------------------------------------------
$ write SYS$ERROR F$FAO("%!AS-I-COMPILE, module!AS: !AS", _NAME, -
	BLDRUN_T_MODULE_COUNTER, T_MODULE)
$!	^^ supplied by BLDRUN.COM      ^^ P2
$! ----------------------------------------------------------------------------
$ _OBJDEV = F$PARSE(BLDRUN_GT_OLBFILESPEC,,,"DEVICE")
$ _OBJDIR = F$PARSE(BLDRUN_GT_OLBFILESPEC,,,"DIRECTORY")
$ _OBJLOC = _OBJDEV + _OBJDIR
$! ----------------------------------------
$ if (F$SEARCH(BLDRUN_GT_OLBFILESPEC) .eqs. "")
$ then
$   write SYS$ERROR "''_NAME'-F-NOSUCHOLB, missing object library"
$   write SYS$ERROR " \",BLDRUN_GT_OLBFILESPEC,"\"
$   set DEFAULT '_DEFAULT'
$   exit %X2C
$ endif
$! ----------------------------------------
$ set DEFAULT PYTHON_VMS:
$ set DEFAULT [-.PYTHON]
$ _INCL_PYTHON = F$ENVIRONMENT("DEFAULT")
$ set DEFAULT [-.'T_OLBNAM']
$! -----
$! P5 = /DEFINE specifications (no prefix-comma or trailing-')'!
$!--
$! ----------------------------------------------------------------------------
$ if (F$GETSYI("CPU") .GT. 127)
$ then
$   _ARCH = "ALPHA"
$   _PRFX = "/PREFIX_LIBRARY_ENTRIES=ALL_ENTRIES"
$ else
$   _ARCH = "VAX"
$   _PRFX = ""
$ endif
$! -----
$ if (T_COMP .eqs. "P")
$ then
$   ! overwrite previous value for POSIX environment
$   _PRFX = "/PREFIX_LIBRARY_ENTRIES=(ALL_ENTRIES,RTL=""posixc$"")"
$ endif
$! ----------------------------------------------------------------------------
$ _P      = F$LOCATE("/",T_MODULE)
$ _CCQUAL = F$EXTRACT(_P,9999,T_MODULE)
$ if (_P .ne. F$LENGTH(T_MODULE))
$ then
$   T_MODULE = F$ELEMENT(0,"/",T_MODULE)
$ endif
$ if (_CFG_THREADS)
$ then
$   _CCQUAL = _CCQUAL + "/member_align"	! (VAX DEC C)
$ endif
$! ----------------------------------------------------------------------------
$ if (T_COMP .eqs. "P")
$ then
$   _PSXINCL = "POSIX$INCLUDE:,"
$ else
$   _PSXINCL = ""
$ endif
$!				 ! v- incl ","	    ! v- VMS__IMPORTDL.C
$ _QUAL_INCL = "/INCLUDE=(''PSXINCL'PYTHON_INCLUDE:,'_INCL_PYTHON',PYTHON_VMS:,[]"
$ if (P4 .eqs. "")
$ then
$   P4 = ")"
$ else
$   P4 = "," + P4 + ")"
$ endif
$ _QUAL_INCL = _QUAL_INCL + P4
$! ----------------------------------------------------------------------------
$ P5 = "" ! @@@
$ if (P5 .eqs. "")
$ then
$   _QUAL_DEF = ""
$ else
$   _QUAL_DEF = P5
$ endif
$ if (_CFG_THREADS)
$ then
$   if (_QUAL_DEF .nes. "")
$   then
$	_QUAL_DEF = _QUAL_DEF + ","
$   endif
$   _QUAL_DEF = _QUAL_DEF + "WITH_THREAD=1"
$ endif
$! -----
$ if (T_COMP .eqs. "P")
$ then
$   if (_QUAL_DEF .nes. "")
$   then
$	_QUAL_DEF = _QUAL_DEF + ","
$   endif
$   _QUAL_DEF = _QUAL_DEF + "__VMS_POSIX=1"
$ endif
$! -----
$ if (_QUAL_DEF .nes. "")
$ then
$   _QUAL_DEF = "/DEFINE=(" + _QUAL_DEF + ")"
$ endif
$! ----------------------------------------------------------------------------
$ if (_CFG_DEBUG)
$ then
$   _QUAL_DBGOPT = "/DEBUG/noOPTIMIZE"
$ else
$   _QUAL_DBGOPT = "/noDEBUG/OPTIMIZE"
$ endif
$! ----------------------------------------------------------------------------
$ if (T_COMP .eqs. "P")
$ then
$   define /user_mode VAXC$INCLUDE         POSIX$INCLUDE:
$   define /user_mode C$INCLUDE            POSIX$INCLUDE:
$   define /user_mode C$LIBRARY            POSIX$INCLUDE:POSIX$CDEF.TLB
$   define /user_mode DECC$LIBRARY_INCLUDE POSIX$INCLUDE:
$   define /user_mode NETINET              POSIX$INCLUDE:
$   define /user_mode SYS                  POSIX$INCLUDE:
$ endif
$! ----------------------------------------------------------------------------
$ on ERROR then $ goto ERR_CC
$ CC '_QUAL_DBGOPT' - !/WARNING=noINFORMATION -
  '_QUAL_INCL' '_CCQUAL' -
  '_QUAL_DEF' -    ! v-- .OBJ, .O
  /OBJECT= '_OBJLOC''_OBJTYP' -
  'T_MODULE'.C '_PRFX'
$! ----------------------------------------------------------------------------
$ _OBJ = F$PARSE(T_MODULE,,,"NAME")	! extract module name
$ if (_OBJ .eqs. "") ! ?
$ then
$   _OBJ = T_MODULE
$ endif
$!
$ if (T_OLB .eqs. "K")	! keep object module
$ then
$   T_OLB = "1"
$   CC_X_NODELETE_OBJ = "1"
$ endif
$!
$ if (T_OLB)	! .OBJ file might not be put into library (e.g. MAIN)
$ then		! _OBJTYP = ".OBJ" or ".O"
$   library /replace 'BLDRUN_GT_OLBFILESPEC' 'F$PARSE(_OBJLOC,_OBJ,_OBJTYP)' ! /log
$   if ("''CC_X_NODELETE_OBJ'")
$   then
$	write SYS$OUTPUT "%''_NAME'-I-OBJNOTDEL, object file not deleted: ", T_MODULE
$	set PROTECTION=(G:RE,W:RE) 'F$PARSE(_OBJLOC,_OBJ,_OBJTYP)'
$   else
$	delete 'F$PARSE(_OBJDIR,_OBJ,_OBJTYP)'* ! /log
$   endif
$ else
$   set PROTECTION=(G:RE,W:RE) 'F$PARSE(_OBJLOC,_OBJ,_OBJTYP)'
$ endif
$! ----------------------------------------------------------------------------
$!
$ERR_CC:
$PROC_EXIT:
$ set DEFAULT '_DEFAULT'
$ exit 1 ! CC_PYTHON.COM
