#++
# DAY_OF_YEAR.PY
#
# calculate day of year -- 25-FEB-2000 Uwe Zessin
#
# Example:
# $python PYTHON_TOOLS:DAY_OF_YEAR.PY "25-FEB-2000"
# doy= 56
# $
#--

def day_of_year (date):
    import vms_sys

    # index into |wa_timbuf|, output of sys$numtim
    K_YEAR_SINCE_0         = 0
    K_MONTH_OF_YEAR        = 1
    K_DAY_OF_MONTH         = 2
    K_HOUR_OF_DAY          = 3
    K_MINUTE_OF_HOUR       = 4
    K_SECOND_OF_MINUTE     = 5
    K_HUNDREDTHS_OF_SECOND = 6

    # convert ASCII to binary representation
    q_bintim = vms_sys.bintim (date)

    # split up
    wa_timbuf = vms_sys.numtim (q_bintim)

    days_in_months = [31,28,31,30,31,30,31,31,30,31,30,31]

    # @@ this breaks in year 2100 which is not a leap year
    if ((wa_timbuf[K_YEAR_SINCE_0] % 4) == 0):
        days_in_months[1] = 29  # february, index starts at 0

    l_doy = 0
    for loop in range (wa_timbuf[K_MONTH_OF_YEAR]-1):
        l_doy = l_doy + days_in_months[loop]

    l_doy = l_doy + wa_timbuf[K_DAY_OF_MONTH]

    return (l_doy)

# def day_of_year (date):

# ----------------------------------------

def doy_test (date):
    print date,
    try:
        print day_of_year(date)
    except:
        print '** exception**'
# def doy_test (date):

# ----------------------------------------

if __name__=='__main__':
    import sys

    if (sys.argv[1] == 'TEST'):
        doy_test("1-JAN-2000" )
        doy_test("2-JAN-2000" )
        doy_test("1-FEB-2000" )
        doy_test("28-FEB-2000")
        doy_test("29-FEB-2000")
        doy_test("30-FEB-2000")
        doy_test("1-MAR-2000" )
    else:
        print day_of_year (sys.argv[1])
# __main__

# EOF: DAY_OF_YEAR.PY
