$!++
$! MACRO_VMS.COM - compile a module + put .OBJ in .OLB
$!
$! Parameters:
$!	P1 =
$!	    "OLBFILESPEC|t_olbnam|l_version"
$!			- return .OLB filespec in BLDRUN_GT_OLBFILESPEC
$!	    "COMPILE|t_olbnam|l_version"
$!		T_OLBNAM - .OLB name (full filespec in a symbol - see below)
$!
$!	P2 = T_MODULE	- module name (VMS_MACRO)
$!	P3 = "t_olb|t_dbg|t_thread|t_envcomp|t_ver_a|t_ver_v"
$!		T_OLB	  - do/don't put .OBJ in .OLB
$!		T_DBG	  - A]lways, N]ever, C]config-depended CC/DEBUG
$!		T_THREAD  - WITH_THREAD
$!		T_ENVCOMP - Environment=Compiler
$!		T_VER_A	  - OpenVMS Alpha version
$!		T_VER_V	  - OpenVMS VAX version
$!	P4 = T_INCL	  - /INCLUDE=
$!
$!	Symbols supplied by caller BLDRUN.COM:
$!		BLDRUN_T_MODULE_COUNTER		- diagnostic output
$!		BLDRUN_GT_OLBFILESPEC		- reused after "OLBFILESPEC"
$!
$! Returns:
$!	BLDRUN_GT_OLBFILESPEC if P1="OLBFILESPEC"
$!--
$! ----------------------------------------------------------------------------
$ _PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ _NAME      = F$PARSE(_PROCEDURE,,,"NAME")
$!
$ _DEFAULT = F$ENVIRONMENT("DEFAULT")
$! ----------------------------------------------------------------------------
$ T_OPERATION   = F$ELEMENT(0,"|",P1)
$ T_OLBNAM      = F$ELEMENT(1,"|",P1)
$ L_PAR_VERSION = F$ELEMENT(2,"|",P1) ! parameter handling
$! ----------------------------------------------------------------------------
$ if (F$TRNLNM("PYTHON_CFG_ENVIRONMENT") .eqs. "DCL")
$ then
$   _CFG_ENV_NAM = "D"	! DCL
$   _OBJTYP = ".OBJ"
$   _OLBTYP = ".OLB"
$ else
$   _CFG_ENV_NAM = "P"	! assume POSIX
$   _OBJTYP = ".O"
$   _OLBTYP = ".A"
$ endif ! (F$TRNLNM("PYTHON_CFG_ENVIRONMENT"))
$! ----------------------------------------------------------------------------
$ if (T_OPERATION .eqs. "OLBFILESPEC")
$ then
$   BLDRUN_GT_OLBFILESPEC == "?"
$   set DEFAULT PYTHON_OLB:
$   ! --------------------
$   ! -- build filename
$   if (F$TRNLNM("PYTHON_CFG_DEBUG"))
$   then
$     _CFG_DBG_NAM = "D"
$   else
$     _CFG_DBG_NAM = "0"
$   endif ! (F$TRNLNM("PYTHON_CFG_DEBUG"))
$   !
$   if (F$TRNLNM("PYTHON_CFG_THREADS"))
$   then
$     _CFG_THR_NAM = "T"
$   else
$     _CFG_THR_NAM = "0"
$   endif
$   !
$   _OLBFIL = T_OLBNAM + "_" + _CFG_ENV_NAM + _CFG_DBG_NAM + _CFG_THR_NAM
$   ! --------------------
$   BLDRUN_GT_OLBFILESPEC == F$PARSE(_OLBFIL,"PYTHON_OLB:''_OLBTYP'")
$   ! --------------------
$   set DEFAULT '_DEFAULT'
$   exit 1
$ endif ! (T_OPERATION .eqs. "OLBFILESPEC")
$! ----------------------------------------------------------------------------
$ if (T_OPERATION .nes. "COMPILE")
$ then
$     write SYS$ERROR "%''_NAME'-F-BADP1, invalid value for parameter 1"
$     set DEFAULT '_DEFAULT'
$     exit %X2C
$ endif
$! ----------------------------------------------------------------------------
$! T_OPERATION == "COMPILE|module"
$!
$ T_MODULE = P2
$ T_OLB    = F$ELEMENT(0,"|",P3)
$ T_DBG    = F$ELEMENT(1,"|",P3)
$ T_THREAD = F$ELEMENT(2,"|",P3)
$ T_VER_A  = F$ELEMENT(3,"|",P3)
$ T_VER_V  = F$ELEMENT(4,"|",P3)
$! ----------------------------------------------------------------------------
$ if (F$EXTRACT (0,1,T_OLBNAM .eqs. "@"))
$ then
$   X_NEWOLBFIL = "TRUE"		! create a new object library
$   T_OLBNAM    = F$EXTRACT(1,F$LENGTH(T_OLBNAM),T_OLBNAM) ! remove "@"
$ else
$   X_NEWOLBFIL = "FALSE
$ endif
$! ----------------------------------------------------------------------------
$! write SYS$OUTPUT F$FAO("!79*-")
$ _DEFAULT = F$ENVIRONMENT("DEFAULT")
$ on ERROR then $ goto PROC_EXIT
$!
$ _DEVICE    = F$PARSE(_PROCEDURE,,,"DEVICE")
$ _DIRECTORY = F$PARSE(_PROCEDURE,,,"DIRECTORY")
$ _PROCEDURE = F$ENVIRONMENT("PROCEDURE")
$ _NAME      = F$PARSE(_PROCEDURE,,,"NAME")
$! ----------------------------------------------------------------------------
$ _CFG_TXT = ""
$ if (T_DBG .eqs. "A")		! A]lways compile with /DEBUG
$ then
$   _CFG_DEBUG   = 1
$   _CFG_TXT     = "DEBUG,"
$   _CFG_DBG_NAM = "D"
$ else
$   if (T_DBG .eqs. "N")	! N]ever compile with /DEBUG
$   then
$     _CFG_DEBUG   = 1
$     _CFG_TXT     = "DEBUG,"
$     _CFG_DBG_NAM = "D"
$   else			! everything else is assumed: C]onfig-depended
$     if (F$TRNLNM("PYTHON_CFG_DEBUG"))
$     then
$       _CFG_DEBUG   = 1
$       _CFG_TXT     = "DEBUG,"
$       _CFG_DBG_NAM = "D"
$     else
$       _CFG_DEBUG   = 0
$       _CFG_TXT     = "noDEBUG,"
$       _CFG_DBG_NAM = "0"
$     endif ! (F$TRNLNM("PYTHON_CFG_DEBUG"))
$   endif ! (T_DBG .eqs. "N")
$ endif ! (T_DBG .eqs. "A")
$! ----------------------------------------------------------------------------
$ if (F$TRNLNM("PYTHON_CFG_THREADS"))
$ then
$   _CFG_THREADS = 1
$   _CFG_TXT     = _CFG_TXT + "THREADS"
$   _CFG_THR_NAM = "T"
$ else
$   _CFG_THREADS = 0
$   _CFG_TXT     = _CFG_TXT + "noTHREADS"
$   _CFG_THR_NAM = "0"
$ endif
$!
$ if (T_THREAD .eqs. "T")
$ then
$   if (.not. _CFG_THREADS)
$   then
$     write SYS$ERROR F$FAO("%!AS-I-NOTCOMP, module!AS: !AS", _NAME, -
	    BLDRUN_T_MODULE_COUNTER, T_MODULE)
$	    ! ^^ supplied by BLDRUN.COM    ^^ P2
$     write SYS$ERROR "-''_NAME'-I-NOTHCFG, thread support not configured"
$     set DEFAULT '_DEFAULT'
$     exit 1
$   endif
$ endif
$! ----------------------------------------------------------------------------
$!+
$! check if configured environment + module environment matches
$!-
$ T_ENV = F$ELEMENT(0,"=",T_ENVCOMP)
$!            (valid in both envs)   (valid in current env)
$ if (.not. ( (T_ENV .eqs. "B") .or. (T_ENV .eqs. _CFG_ENV_NAM) ))
$ then
$     write SYS$ERROR F$FAO("%!AS-I-NOTCOMP, module!AS: !AS", _NAME, -
	    BLDRUN_T_MODULE_COUNTER, T_MODULE)
$	    ! ^^ supplied by BLDRUN.COM    ^^ P2
$     write SYS$ERROR "-''_NAME'-I-ENVMISM, environment mismatch - CFG=''_CFG_ENV_NAM', MODULE=''T_ENV'"
$     set DEFAULT '_DEFAULT'
$     exit 1
$ endif
$ T_COMP = F$ELEMENT(1,"=",T_ENVCOMP)
$! ----------------------------------------------------------------------------
$ write SYS$ERROR F$FAO("%!AS-I-COMPILE, module!AS: !AS", _NAME, -
	BLDRUN_T_MODULE_COUNTER, T_MODULE)
$!	^^ supplied by BLDRUN.COM ^^ P2
$! ----------------------------------------------------------------------------
$ _OBJDEV = F$PARSE(BLDRUN_GT_OLBFILESPEC,,,"DEVICE")
$ _OBJDIR = F$PARSE(BLDRUN_GT_OLBFILESPEC,,,"DIRECTORY")
$ _OBJLOC = _OBJDEV + _OBJDIR
$! ----------------------------------------
$ if (F$SEARCH(BLDRUN_GT_OLBFILESPEC) .eqs. "")
$ then
$   write SYS$ERROR "''_NAME'-F-NOSUCHOLB, missing object library"
$   write SYS$ERROR " \",BLDRUN_GT_OLBFILESPEC,"\"
$   set DEFAULT '_DEFAULT'
$   exit %X2C
$ endif
$! ----------------------------------------
$ set DEFAULT PYTHON_VMS:
$! -----
$! @@old DCC.COM parameters:
$! P4 = more /INCLUDE specifications (no prefix-comma or trailing-')'!
$! P5 = /DEFINE specifications (no prefix-comma or trailing-')'!
$!--
$! ----------------------------------------------------------------------------
$ if (F$GETSYI("CPU") .GT. 127)
$ then
$   _ARCH = "ALPHA"
$ else
$   _ARCH = "VAX"
$ endif
$! ----------------------------------------------------------------------------
$ if (_CFG_DEBUG)
$ then
$   _QUAL_DBG = "/DEBUG"
$ else
$   _QUAL_DBG = "/noDEBUG"
$ endif
$! ----------------------------------------------------------------------------
$!! write SYS$ERROR "%MACRO_VMS-I-COMPMOD, compiling module ",T_MODULE
$ on ERROR then $ goto ERR_MACRO
$ macro '_QUAL_DBG' /OBJECT= '_OBJLOC''_OBJTYP'  'T_MODULE'
$! ----------------------------------------------------------------------------
$ _OBJ = F$PARSE(T_MODULE,,,"NAME")	! extract module name
$ if (_OBJ .eqs. "") ! ?
$ then
$   _OBJ = T_MODULE
$ endif
$!
$ if (T_OLB)	! .OBJ file might not be put into library (e.g. MAIN)
$ then		! _OBJTYP = ".OBJ" or ".O"
$   library /replace 'BLDRUN_GT_OLBFILESPEC' 'F$PARSE(_OBJLOC,_OBJ,_OBJTYP)' ! /log
$   ! F$PARSE, because DCC.COM is called from PCC_VMS.COM, too
$   if ("''CC_X_NODELETE_OBJ'")
$   then
$	write SYS$OUTPUT "%''_NAME'-I-OBJNOTDEL, object file not deleted: ", T_MODULE
$	set PROTECTION=(G:RE,W:RE) 'F$PARSE(_OBJLOC,_OBJ,_OBJTYP)'
$   else
$	delete 'F$PARSE(_OBJDIR,_OBJ,_OBJTYP)'* ! /log
$   endif
$ else
$   set PROTECTION=(G:RE,W:RE) 'F$PARSE(_OBJLOC,_OBJ,_OBJTYP)'
$ endif
$! ----------------------------------------------------------------------------
$ERR_MACRO:
$PROC_EXIT:
$ set DEFAULT '_DEFAULT'
$ exit 1 ! MACRO_VMS.COM
