/* VMS__IMPORTDL.C -- 27-AUG-1999 Uwe Zessin
   OpenVMS specific import for modules as shareable images
   This file was copied from V1.5.2 [.MODULES]IMPORTDL.C
*/

#ifdef __DECC
#pragma module VMS__IMPORTDL "19990830"
#endif

/***********************************************************
Copyright 1991-1995 by Stichting Mathematisch Centrum, Amsterdam,
The Netherlands.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the names of Stichting Mathematisch
Centrum or CWI or Corporation for National Research Initiatives or
CNRI not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

While CWI is the initial source for this software, a modified version
is made available by the Corporation for National Research Initiatives
(CNRI) at the Internet address ftp://ftp.python.org.

STICHTING MATHEMATISCH CENTRUM AND CNRI DISCLAIM ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL STICHTING MATHEMATISCH
CENTRUM OR CNRI BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

******************************************************************/

#ifdef __DECC
#pragma __nostandard	/* non-ANSI-Standard feature */
/* int decc$from_vms(...);
int decc$to_vms(...); */
#pragma __standard
#include <unixlib.h>
#endif /* __DECC */
#include <descrip.h>
#include <fscndef.h>		/* FSCN$_ */
#include <lib$routines.h>
#include <libdef.h>		/* LIB$_name */
#include <starlet.h>		/* SYS$FILESCAN() */

#include "vmsdef.h"		/* itmlst2 */

#include <ctype.h>		/* toupper() */

/* Support for dynamic loading of extension modules */
/* If no dynamic linking is supported, this file still generates some code! */

#include "Python.h"

#ifdef HAVE_SYS_PARAM_H
/* osdefs.h will define MAXPATHLEN if it's not already defined. */
#include <sys/param.h>
#endif
#include "osdefs.h"
#include "importdl.h"

/* Explanation of some of the the various #defines used by dynamic linking...

   symbol	-- defined for:

   DYNAMIC_LINK -- any kind of dynamic linking
   USE_SHLIB	-- SunOS or IRIX 5 (SVR4?) shared libraries
   _DL_FUNCPTR_DEFINED	-- if the typedef dl_funcptr has been defined
   SHORT_EXT	-- short extension for dynamic module, e.g. ".so"
   LONG_EXT	-- long extension, e.g. "module.so"

   (The other WITH_* symbols are used only once, to set the
   appropriate symbols.)
*/

/* Configure dynamic linking */

#define DYNAMIC_LINK
#include <errno.h>
typedef void (*dl_funcptr)();
#define _DL_FUNCPTR_DEFINED 1
#define SHORT_EXT ".exe"
#define LONG_EXT "_module.exe"
#define FUNCNAME_PATTERN "init%.200s"

struct filedescr _PyImport_Filetab[] = {
#ifdef SHORT_EXT
	{SHORT_EXT, "rb", C_EXTENSION},
#endif /* !SHORT_EXT */
#ifdef LONG_EXT
	{LONG_EXT, "rb", C_EXTENSION},
#endif /* !LONG_EXT */
	{".py", "r", PY_SOURCE},
	{".pyc", "rb", PY_COMPILED},
	{0, 0}
};

#ifdef NO_DYNAMIC_LINK
#undef DYNAMIC_LINK
#endif


/* ++++++++++++++++++++++++++++++++++++++++ */
static char*    psxmod_gat_vmspath;

static int psxmod_to_vms_action (char *spec, int x)
{
    (void)strcpy (psxmod_gat_vmspath, spec);
    return 1;
}
/* ++++++++++++++++++++++++++++++++++++++++ */

long vms__import_fis
	(struct dsc$descriptor_s * ar_filename
	,struct dsc$descriptor_s * ar_symbol
	,long			 * al_symbol_value
	,struct dsc$descriptor_s * ar_image_name
	)
{
	unsigned long l_status;

	/* -------------------- */
	/* establish a condition handler to trap any signals and */
	/*  turn them into return values */
	(void) lib$establish (lib$sig_to_ret);
	/* no condition value is returned */

	/* -------------------- */
	l_status = lib$find_image_symbol
		(ar_filename
		,ar_symbol
		,al_symbol_value
		,ar_image_name);

	/* -------------------- */
	return (l_status);
} /* vms__import_fis () */
/* ++++++++++++++++++++++++++++++++++++++++ */
/* = load_dynamic_module */
PyObject *
_PyImport_LoadDynamicModule(name, pathname, fp)
	char *name;
	char *pathname;
	FILE *fp;
{
#ifndef DYNAMIC_LINK
	PyErr_SetString(PyExc_ImportError,
			"dynamically linked modules not supported");
	return NULL;
#else
	PyObject *m, *d, *s;
	char funcname[258];
	char *lastdot, *shortname, *packagecontext;
	dl_funcptr p = NULL;
#ifdef USE_SHLIB
	static struct {
		dev_t dev;
		ino_t ino;
		void *handle;
	} handles[128];
	static int nhandles = 0;
	char pathbuf[260];
	if (strchr(pathname, '/') == NULL)
	{
		/* Prefix bare filename with "./" */
		sprintf(pathbuf, "./%-.255s", pathname);
		pathname = pathbuf;
	}
#endif
	/* printf ("@@_PyImport_LoadDynamicModule, name=%s,\n pathname=%s,\n",
		name, pathname); */

	/* -------------------- */
	/* convert filespec from UNIX format to OpenVMS format */
    {
	long	l_allow_wild;
	long	l_no_directory;
	long	l_status;

	l_allow_wild      = 0;		/* default = no wildcards */
	l_no_directory    = 0;		/* default = prevent expansion */

	psxmod_gat_vmspath = malloc (2000); /* @@@ currently not free()d */
	l_status = decc$to_vms
		(pathname
		,psxmod_to_vms_action
		,l_allow_wild
		,l_no_directory );
	/* printf ("@@ vms:%s,\n", psxmod_gat_vmspath); */
    }

	/* -------------------- */
	m = _PyImport_FindExtension(name, pathname);
	if (m != NULL)
	{
	    Py_INCREF(m);
	    return m;
	}
	lastdot = strrchr(name, '.');
	if (lastdot == NULL)
	{
	    packagecontext = NULL;
	    shortname = name;
	}
	else
	{
	    packagecontext = name;
	    shortname = lastdot+1;
	}

	/* -------------------- */
	sprintf(funcname, FUNCNAME_PATTERN, shortname);

	/* -------------------- */
	/* @@ upcase funcnam */
    {
	char * a_chr;

	a_chr = funcname;
	while (*a_chr != '\0')
	{
	    *a_chr = toupper (*a_chr);
	    a_chr++;
	}
    }
	/* printf ("@@ funcname=%s, shortnam=%s,\n", funcname, shortname); */

	/* -------------------- */
#ifdef USE_SHLIB
	if (fp != NULL)
	{
	    int i;
	    struct stat statb;
	    fstat(fileno(fp), &statb);
	    for (i = 0; i < nhandles; i++)
	    {
		if (statb.st_dev == handles[i].dev &&
		    statb.st_ino == handles[i].ino)
		{
		    p = (dl_funcptr) dlsym(handles[i].handle, funcname);
		    goto got_it;
		}
	    }
	    if (nhandles < 128)
	    {
		handles[nhandles].dev = statb.st_dev;
		handles[nhandles].ino = statb.st_ino;
	    }
	}
	{
	    void *handle = dlopen(pathname, RTLD_NOW);
	    if (handle == NULL)
	    {
		PyErr_SetString(PyExc_ImportError, dlerror());
		return NULL;
	    }
	    if (fp != NULL && nhandles < 128)
		handles[nhandles++].handle = handle;
	    p = dlsym(handle, funcname);
	}
  got_it:
#endif /* USE_SHLIB */
/* @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */

	/* -------------------- */
    {
	struct dsc$descriptor_s   r_srcstr;

	/* VMS item-list to be passed to SYS$FILESCAN() */
	struct vmsdef_xr_itmlst2 * ar_itemlist;		/* start address */
	struct vmsdef_xr_itmlst2 * ar_itemlist_ptr;	/* walk along    */

	unsigned long		  l_malloc_bytes;
	unsigned long		  l_status;

	char			* at_filename;
	struct dsc$descriptor_s   r_filename;
	unsigned long		  l_filename_len;

	struct dsc$descriptor_s   r_symbol;

	char			* at_image_name;
	struct dsc$descriptor_s   r_image_name;
	unsigned long		  l_image_name_len;

	long			  l_symbol_value;

	/* -------------------- */
	/* source string in VMS format to SYS$FILESCAN() */
	r_srcstr.dsc$w_length  = strlen (psxmod_gat_vmspath);
	r_srcstr.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_srcstr.dsc$b_class   = DSC$K_CLASS_S;
	r_srcstr.dsc$a_pointer = psxmod_gat_vmspath;

	/* -------------------- */
	/* build itemlist_2 for SYS$FILESCAN() */
#define l_itmlst_size 4		/* FSCN$_DEVICE, _DIRECTORY, _NAME, _TYPE */

	l_malloc_bytes =
	    ( (l_itmlst_size * sizeof(struct vmsdef_xr_itmlst2)) + /* items */
	      sizeof(struct vmsdef_xr_itmlst2)	 /* termination of itemlist */
	    );

	ar_itemlist = malloc (l_malloc_bytes);
	if (ar_itemlist == NULL)
	{
	    return PyErr_NoMemory();
	}

	/* Set the allocated memory to 0. */
	(void) memset (ar_itemlist, 0, l_malloc_bytes);

	/* ar_itemlist_ptr is used to walk along the individual elements */
	/*  in the VMS item-list */
	ar_itemlist_ptr = ar_itemlist;

	ar_itemlist_ptr->w_itmcod = FSCN$_DEVICE;
	ar_itemlist_ptr++;
	ar_itemlist_ptr->w_itmcod = FSCN$_DIRECTORY;
	ar_itemlist_ptr++;
	ar_itemlist_ptr->w_itmcod = FSCN$_NAME;
	ar_itemlist_ptr++;
	ar_itemlist_ptr->w_itmcod = FSCN$_TYPE;
	/* termination done by memset() above */

	/* -------------------- */
	l_status = sys$filescan
		(&r_srcstr
		,ar_itemlist
		,0	/* &l_fldflags */
		,0	/* &r_auxout */
		,0	/* &w_retlen */
		);
	if (l_status != 1) /* SS$_NORMAL */
	{
	    (void) free (ar_itemlist);
	    PyErr_Format(PyExc_ImportError,
		   "dynamic module - SYS$FILESCAN()= %d", l_status);
	    return NULL;
	}

	/* -------------------- */
	/* @@ print result */
	/*  in the VMS item-list */
	/* ar_itemlist_ptr = ar_itemlist;                         */
	/* while (ar_itemlist_ptr->w_itmcod != 0)                 */
	/* {                                                      */
	/*     if (ar_itemlist_ptr->a_bufadr != 0)                */
	/*     {                                                  */
	/* 	printf("itmcod=%d\n", ar_itemlist_ptr->w_itmcod); */
	/* 	printf(" len=%d\n",   ar_itemlist_ptr->w_bufsiz); */
	/* 	printf(" str=%s\n",   ar_itemlist_ptr->a_bufadr); */
	/*     }                                                  */
	/*     ar_itemlist_ptr++;                                 */
	/* }                                                      */

	/* -------------------- */
	/* calculate sizes - need to combine DEVICE+DIRECTORY+TYPE */
	l_image_name_len  = 0;
	l_filename_len    = 0;

	ar_itemlist_ptr   = ar_itemlist;
	l_image_name_len += ar_itemlist_ptr->w_bufsiz; /* FSCN$_DEVICE */	
	ar_itemlist_ptr++;
	l_image_name_len += ar_itemlist_ptr->w_bufsiz; /* FSCN$_DIRECTORY */	
	ar_itemlist_ptr++;

	l_filename_len    = ar_itemlist_ptr->w_bufsiz; /* FSCN$_NAME */
	/* !!!!!!!! -> r_filename */

	ar_itemlist_ptr++;
	l_image_name_len += ar_itemlist_ptr->w_bufsiz; /* FSCN$_TYPE */
	/* !!!!!!!! -> r_image_name */

	/* -------------------- */
	/* allocate string buffers for LIB$FIND_IMAGE_SYMBOL() */
	at_image_name = malloc (l_image_name_len + 1);
	if (at_image_name == NULL)
	{
	    (void) free (ar_itemlist);
	    return PyErr_NoMemory();
	}
	(void) memset (at_image_name, 0, (l_image_name_len + 1));

	at_filename = malloc (l_filename_len + 1);
	if (at_filename == NULL)
	{
	    (void) free (ar_itemlist);
	    (void) free (at_image_name);
	    return PyErr_NoMemory();
	}
	(void) memset (at_filename, 0, (l_filename_len + 1));

	/* -------------------- */
	/* fill (copy) string buffers for LIB$FIND_IMAGE_SYMBOL */
	ar_itemlist_ptr = ar_itemlist;		/* FSCN$_DEVICE */
	(void) strncpy (at_image_name
			,ar_itemlist_ptr->a_bufadr
			,(unsigned int)ar_itemlist_ptr->w_bufsiz);
	ar_itemlist_ptr++;

	(void) strncat (at_image_name		/* FSCN$_DIRECTORY */
			,ar_itemlist_ptr->a_bufadr
			,(unsigned int)ar_itemlist_ptr->w_bufsiz);
	ar_itemlist_ptr++;

	(void) strncpy (at_filename		/* FSCN$_NAME */
			,ar_itemlist_ptr->a_bufadr
			,(unsigned int)ar_itemlist_ptr->w_bufsiz);
	ar_itemlist_ptr++;

	(void) strncat (at_image_name		/* FSCN$_TYPE */
			,ar_itemlist_ptr->a_bufadr
			,(unsigned int)ar_itemlist_ptr->w_bufsiz);

	/* -------------------- */
	/* the SYS$FILESCAN() itemlist is no longer needed */
	(void) free(ar_itemlist);

	/* -------------------- */
	/* printf ("@@at_filename=%s\n", at_filename);     */
	/* printf ("@@at_image_name=%s\n", at_image_name); */
	/* printf ("@@funcname=%s\n", funcname);           */

/* @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */
	/* -------------------- */
	/* set up string descriptors for LIB$FIND_IMAGE_SYMBOL */
	r_filename.dsc$w_length  = strlen (at_filename);
	r_filename.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_filename.dsc$b_class   = DSC$K_CLASS_S;
	r_filename.dsc$a_pointer = at_filename;

	r_symbol.dsc$w_length  = strlen (funcname);
	r_symbol.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_symbol.dsc$b_class   = DSC$K_CLASS_S;
	r_symbol.dsc$a_pointer = funcname;

	r_image_name.dsc$w_length  = strlen (at_image_name);
	r_image_name.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_image_name.dsc$b_class   = DSC$K_CLASS_S;
	r_image_name.dsc$a_pointer = at_image_name;

	l_symbol_value = 0;

	/* -------------------- */
	/* call jacket routine - it is used to catch signals */
	l_status = vms__import_fis
		(&r_filename
		,&r_symbol
		,&l_symbol_value
		,&r_image_name);

	/* -------------------- */
	/* printf ("@@ lib$fis status=%d\n", l_status); */
	if (l_status != 1) /* SS$_NORMAL */
	{
	    (void) free (at_filename);
	    (void) free (at_image_name);

	    if (l_status == LIB$_KEYNOTFOU)
	    {
		PyErr_Format(PyExc_ImportError,
		    "dynamic module does not define init function (%.200s)",
		    funcname);
	    }
	    else
	    {
		PyErr_Format(PyExc_ImportError,
		    "dynamic module - LIB$FIND_IMAGE_SYMBOL()= %d", l_status);
	    }
	    return NULL;
	}

        p = (dl_funcptr) l_symbol_value;	/* init routine of module */
    }
/* @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */

	/* -------------------- */
	/* l_status == %LIB-F-KEYNOTFOU, key not found in tree */
	if (p == NULL)
	{
	    PyErr_Format(PyExc_ImportError,
		    "dynamic module does not define init function (%.200s)",
		     funcname);
	    return NULL;
	}
	_Py_PackageContext = packagecontext;
	(*p)();				    /* CALL init routine of module */
	_Py_PackageContext = NULL;
	if (PyErr_Occurred())
	{
	    return NULL;
	}
	if (_PyImport_FixupExtension(name, pathname) == NULL)
	{
	    return NULL;
	}

	m = PyDict_GetItemString(PyImport_GetModuleDict(), name);
	if (m == NULL)
	{
	    PyErr_SetString(PyExc_SystemError,
				"dynamic module not initialized properly");
	    return NULL;
	}
	/* Remember the filename as the __file__ attribute */
	d = PyModule_GetDict(m);
	s = PyString_FromString(pathname);
	if (s == NULL || PyDict_SetItemString(d, "__file__", s) != 0)
	{
	    PyErr_Clear(); /* Not important enough to report */
	}
	Py_XDECREF(s);
	if (Py_VerboseFlag)
	{
	    PySys_WriteStderr(
			"import %s # dynamically loaded from %s\n",
			name, pathname);
	}
	Py_INCREF(m);
	return m;
#endif /* DYNAMIC_LINK */
}

/* VMS__IMPORTDL.C */
