/* VMS_LBR_DELETE_KEY.C -- 27-SEP-1999 Uwe Zessin
   Python interface to LBR$DELETE_KEY
*/

#ifdef __DECC
#pragma module VMS_LBR_DELETE_KEY "19991221"
#endif

#include "python.h"
#include "vmsdef.h"

#include <descrip.h>

/* ------------------------------------------------------------------------- */
extern PyObject *vms_lbr_gr_error;		/* exception vms_lbr.error */
/* ------------------------------------------------------------------------- */

/* ---------------------------------------- */
/* some DEC C versions are missing LBR$ROUTINES.H */
#ifdef __DECC
#ifndef __DECC_VER	/* don't know if this is defined in all versions ... */
#define __DECC_VER 0
#endif /* __DECC_VER */
#if (__DECC_VER < 60090001) /* @@ might need to change for older version */
#ifndef __unknown_params
#define __unknown_params ...
#endif
#pragma __nostandard	  /* non-ANSI-Standard feature */
unsigned long lbr$delete_key(__unknown_params);
#pragma __standard
#else
#include <lbr$routines.h>
#endif /* __DECC_VER < 60090001 */
#endif /* __DECC */

/* ------------------------------------------------------------------------- */

char vms_lbr_delete_key__doc[] =
"vms_lbr.delete_key (library_index, key_name)\n\
Delete a Key.";

/* ---------------------------------------- */

PyObject *
vms_lbr_delete_key (PyObject *self, PyObject *args)
{
	unsigned long		  l_library_index;

	PyObject		* ar_key_name;
	unsigned long		  l_key_name;

	struct dsc$descriptor_s   r_key_name;
	unsigned long		  l_key_name_len;

	unsigned long		* al_key_name;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "lO",
	    &l_library_index,
	    &ar_key_name ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: library_index */

	/* -------------------- */
	/* argument 2: key_name */
	if (!PyInt_Check(ar_key_name))
	{
	    l_key_name = PyInt_AsLong(ar_key_name);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_key_name = &l_key_name;
	}
	else
	{
	    if (!PyString_Check(ar_key_name))
	    {
		PyErr_SetString(PyExc_TypeError,
		  "argument 2: key_name - must be integer or string");
		return NULL;
	    }
	    l_key_name_len = PyString_Size(ar_key_name);
	    if (l_key_name_len > 65535)
	    {
		PyErr_SetString(PyExc_ValueError,
	     "argument 2: key_name - string size limited to 65535 characters");
		return NULL;
	    }
	    r_key_name.dsc$w_length  = l_key_name_len;
	    r_key_name.dsc$b_dtype   = DSC$K_DTYPE_T;
	    r_key_name.dsc$b_class   = DSC$K_CLASS_S;
	    r_key_name.dsc$a_pointer = PyString_AS_STRING(ar_key_name);
	    al_key_name = (unsigned long *)&r_key_name;
	}

	/* -------------------- */
	l_status = lbr$delete_key
		(&l_library_index
		,al_key_name		/* integer or string !! */
		);

	/* -------------------- */
#ifndef LBR$_NORMAL
#define LBR$_NORMAL 2523137
#endif
	if (l_status == LBR$_NORMAL)
	{
	    Py_INCREF (Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_lbr_gr_error, 1, l_status);
} /* vms_lbr_delete_key() */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_LBR_DELETE_KEY.C */
