/* VMS_LBR_INI_CONTROL.C -- 22-SEP-1999 Uwe Zessin
   Python interface to LBR$INI_CONTROL
*/

#ifdef __DECC
#pragma module VMS_LBR_INI_CONTROL "19991221"
#endif

#include "python.h"
#include "vmsdef.h"

#include "vmsobj_nam.h"
#include <nam.h>

/* ------------------------------------------------------------------------- */
extern PyObject *vms_lbr_gr_error;		/* exception vms_lbr.error */
/* ------------------------------------------------------------------------- */

/* ---------------------------------------- */
/* some DEC C versions are missing LBR$ROUTINES.H */
#ifdef __DECC
#ifndef __DECC_VER	/* don't know if this is defined in all versions ... */
#define __DECC_VER 0
#endif /* __DECC_VER */
#if (__DECC_VER < 60090001) /* @@ might need to change for older version */
#ifndef __unknown_params
#define __unknown_params ...
#endif
#pragma __nostandard	  /* non-ANSI-Standard feature */
unsigned long lbr$ini_control(__unknown_params);
#pragma __standard
#else
#include <lbr$routines.h>
#endif /* __DECC_VER < 60090001 */
#endif /* __DECC */

/* ------------------------------------------------------------------------- */

char vms_lbr_ini_control__doc[] =
"library_index, namblk = vms_lbr.ini_control (func, [type], [namblk])\n\
Initialize a Library Control Structure.";

/* ---------------------------------------- */

PyObject *
vms_lbr_ini_control (PyObject *self, PyObject *args)
{
	unsigned long		  l_library_index;

	unsigned long		  l_func;

	PyObject		* ar_type;
	unsigned long		  l_type;
	unsigned long		* al_type;

	vmsobj_nam		* ar_namblk;
	struct NAM		* ar_vms_nam;

	unsigned long		  l_status;

	/* -------------------- */
	ar_type   = Py_None;
	ar_namblk = (vmsobj_nam *)Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "l|OO",
	    &l_func,
	    &ar_type,
	    &ar_namblk ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: func */

	/* -------------------- */
	/* argument 2: type */
	if (ar_type == Py_None)
	{
	    al_type = 0;		/* skip argument */
	}
	else
	{
	    if (!PyInt_Check(ar_type))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: type - must be integer or None");
		return NULL;
	    }
	    l_type = PyInt_AsLong(ar_type);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_type = &l_type;
	}

	/* -------------------- */
	/* argument 3: namblk */
	if (ar_namblk == (vmsobj_nam *)Py_None)
	{
	    ar_vms_nam = 0;
	}
	else
	{
	    if (! vmsobj_nam_Check(ar_namblk))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 3: namblk - must be vmsobj_nam object or None");
		return NULL;
	    }
	    ar_vms_nam = ar_namblk->ab_nam;
	}

	/* -------------------- */
	l_status = lbr$ini_control
		(&l_library_index
		,&l_func
		,al_type
		,ar_vms_nam
		);

	/* -------------------- */
	if (l_status == 2523137) /* LBR$_NORMAL */
	{
	    return Py_BuildValue ("lO", l_library_index, ar_namblk);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_lbr_gr_error, 1, l_status);
} /* vms_lbr_ini_control() */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_LBR_INI_CONTROL.C */
