/* VMS_SMG_CANCEL_INPUT.C -- 01-APR-2000 Uwe Zessin
   Python interface to SMG$CANCEL_INPUT

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_CANCEL_INPUT

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_CANCEL_INPUT "20000301"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_cancel_input__doc[] =
"None = vms_smg.cancel_input (keyboard_id)\n\
Cancel Input Request.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_cancel_input (PyObject *self, PyObject *args)
{
	unsigned long		  l_keyboard_id;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_keyboard_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: keyboard_id */

	/* -------------------- */
	l_status = smg$cancel_input (&l_keyboard_id);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_cancel_input () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_CANCEL_INPUT.C */
