/* VMS_SMG_CREATE_KEY_TABLE.C -- 05-MAR-2000 Uwe Zessin
   Python interface to SMG$CREATE_KEY_TABLE

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_CREATE_KEY_TABLE

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_CREATE_KEY_TABLE "20000305"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_create_key_table__doc[] =
"key_table_id = vms_smg.create_key_table ()\n\
Create Key Table.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_create_key_table (PyObject *self, PyObject *args)
{
	unsigned long		  l_key_table_id;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, ""))
	{
	    return NULL;
	}

	/* -------------------- */
	/* no arguments */

	/* -------------------- */
	l_key_table_id = 0;

	/* -------------------- */
	l_status = smg$create_key_table (&l_key_table_id);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    return Py_BuildValue ("i", l_key_table_id);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_create_key_table () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_CREATE_KEY_TABLE.C */
