/* VMS_SMG_CURSOR_ROW.C -- 05-MAR-2000 Uwe Zessin
   Python interface to SMG$CURSOR_ROW

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_CURSOR_ROW

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_CURSOR_ROW "20000305"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */

/* ------------------------------------------------------------------------- */

char vms_smg_cursor_row__doc[] =
"row_position = vms_smg.cursor_row (display_id)\n\
Return Cursor Column Position.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_cursor_row (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	unsigned long		  l_cursor_row;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_display_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
/* @@ error conditions are signalled ! */
	l_cursor_row = smg$cursor_row (&l_display_id);

	/* -------------------- */
	return Py_BuildValue ("i", l_cursor_row);

} /* vms_smg_cursor_row () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_CURSOR_ROW.C */
