/* VMS_SMG_DEFINE_KEY.C -- 06-MAR-2000 Uwe Zessin
   Python interface to SMG$DEFINE_KEY

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DEFINE_KEY

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DEFINE_KEY "20000306"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <descrip.h>
#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_define_key__doc[] =
"None = vms_smg.define_key (key_table_id, command_string)\n\
Perform a DEFINE/KEY command.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_define_key (PyObject *self, PyObject *args)
{
	unsigned long		  l_key_table_id;

	char			* at_command_string;
	struct dsc$descriptor_s   r_command_string;
	unsigned long		  l_command_string_len;

	unsigned long		  l_status;

	PyObject		* ar_return;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ls#",
	    &at_command_string, &l_command_string_len,
	    &l_key_table_id
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: key_table_id */

	/* -------------------- */
	/* argument 2: command_string */
	if (l_command_string_len > 65535)
	{
	    PyErr_SetString(PyExc_ValueError,
       "argument 2: command_string - string size limited to 65535 characters");
	    return NULL;
	}
	r_command_string.dsc$w_length  = l_command_string_len;
	r_command_string.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_command_string.dsc$b_class   = DSC$K_CLASS_S;
	r_command_string.dsc$a_pointer = at_command_string;

	/* -------------------- */
	l_status = smg$define_key
		(&l_key_table_id
		,&r_command_string
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_define_key () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DEFINE_KEY.C */
