/* VMS_SMG_DELETE_CHARS.C -- 06-MAR-2000 Uwe Zessin
   Python interface to SMG$DELETE_CHARS

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DELETE_CHARS

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DELETE_CHARS "20000306"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_delete_chars__doc[] =
"status = vms_smg.delete_chars\
 (display_id, number_of_characters, start_row, start_column)\n\
Delete Characters.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_delete_chars (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;
	long			  l_number_of_characters;
	long			  l_start_row;
	long			  l_start_column;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "iiii"
	    ,&l_display_id
	    ,&l_number_of_characters
	    ,&l_start_row
	    ,&l_start_column
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: number_of_characters */

	/* -------------------- */
	/* argument 3: start_row */

	/* -------------------- */
	/* argument 4: start_column */

	/* -------------------- */
	l_status = smg$delete_chars
		(&l_display_id
		,&l_number_of_characters
		,&l_start_row
		,&l_start_column
		);

	/* -------------------- */
	if ((l_status == SS$_NORMAL) || (l_status == SMG$_WILUSERMS))
	{
	    return Py_BuildValue ("i", l_status);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_delete_chars () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DELETE_CHARS.C */
