/* VMS_SMG_DELETE_VIRTUAL_KEYBOARD.C -- 06-MAR-2000 Uwe Zessin
   Python interface to SMG$DELETE_VIRTUAL_KEYBOARD

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DELETE_VIRTUAL_KEYBOARD

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DELETE_VIRTUAL_KEYBOARD "20000306"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_delete_virtual_kbd__doc[] =
"None = vms_smg.delete_virtual_keyboard (keyboard_id)\n\
Delete Virtual Keyboard.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_delete_virtual_keyboard (PyObject *self, PyObject *args)
{
	unsigned long	l_keyboard_id;
	unsigned long	l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "l", &l_keyboard_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: keyboard_id */

	/* -------------------- */
	l_status = smg$delete_virtual_keyboard (&l_keyboard_id);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_delete_virtual_keyboard () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DELETE_VIRTUAL_KEYBOARD.C */
