/* VMS_SMG_DISABLE_UNSOLICITED_INPUT.C -- 01-APR-2000 Uwe Zessin
   Python interface to SMG$DISABLE_UNSOLICITED_INPUT

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DISABLE_UNSOLICITED_INPUT

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DISABLE_UNSOLICITED_INP "20000301"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_disable_unsol_inp__doc[] =
"None = vms_smg.disable_unsolicited_input (pasteboard_id)\n\
Disable Unsolicited Input.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_disable_unsolicited_inp (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_pasteboard_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	l_status = smg$disable_unsolicited_input (&l_pasteboard_id);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_disable_unsolicited_inp () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DISABLE_UNSOLICITED_INPUT.C */
