/* VMS_SMG_DRAW_LINE.C -- 06-MAR-2000 Uwe Zessin
   Python interface to SMG$DRAW_LINE

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DRAW_LINE

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DRAW_LINE "20000306"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_draw_line__doc[] =
"None = vms_smg.draw_line (display_id, start_row, start_column,\
 end_row, end_column, [rendition_set], [rendition_complement])\n\
Draw a Line.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_draw_line (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	long			  l_start_row;
	long			  l_start_column;

	long			  l_end_row;
	long			  l_end_column;

	PyObject		* ar_rendition_set;
	unsigned long		  l_rendition_set;
	unsigned long		* al_rendition_set;

	PyObject		* ar_rendition_complement;
	unsigned long		  l_rendition_complement;
	unsigned long		* al_rendition_complement;

	unsigned long		  l_status;

	/* -------------------- */
	ar_rendition_set        = Py_None;
	ar_rendition_complement = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "iiiii|OO"
	    ,&l_display_id
	    ,&l_start_row
	    ,&l_start_column
	    ,&l_end_row
	    ,&l_end_column
	    ,&ar_rendition_set
	    ,&ar_rendition_complement
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: start_row */
	/* -------------------- */
	/* argument 3: start_column */

	/* -------------------- */
	/* argument 4: end_row */
	/* -------------------- */
	/* argument 5: end_column */

	/* -------------------- */
	/* argument 6: [rendition_set] */
	if (ar_rendition_set == Py_None)
	{
	    al_rendition_set = 0;		/* omitted */
	    l_rendition_set  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_rendition_set))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 6: rendition_set - must be integer or None");
		return NULL;
	    }
	    l_rendition_set = PyInt_AsLong(ar_rendition_set);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_rendition_set = &l_rendition_set;
	}

	/* -------------------- */
	/* argument 7: [rendition_complement] */
	if (ar_rendition_complement == Py_None)
	{
	    al_rendition_complement = 0;		/* omitted */
	    l_rendition_complement  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_rendition_complement))
	    {
		PyErr_SetString(PyExc_TypeError,
		 "argument 7: rendition_complement - must be integer or None");
		return NULL;
	    }
	    l_rendition_complement = PyInt_AsLong(ar_rendition_complement);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_rendition_complement = &l_rendition_complement;
	}

	/* -------------------- */
	l_status = smg$draw_line
		(&l_display_id
		,&l_start_row
		,&l_start_column
		,&l_end_row
		,&l_end_column
		,al_rendition_set
		,al_rendition_complement
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_draw_line () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DRAW_LINE.C */
