/* VMS_SMG_ERASE_CHARS.C -- 09-MAR-2000 Uwe Zessin
   Python interface to SMG$DELETE_CHARS

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_ERASE_CHARS

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_ERASE_CHARS "200003069"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_erase_chars__doc[] =
"None = vms_smg.erase_chars\
 (display_id, number_of_characters, start_row, start_column)\n\
Erase Characters.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_erase_chars (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;
	long			  l_number_of_characters;
	long			  l_start_row;
	long			  l_start_column;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "iiii"
	    ,&l_display_id
	    ,&l_number_of_characters
	    ,&l_start_row
	    ,&l_start_column
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: number_of_characters */

	/* -------------------- */
	/* argument 3: start_row */

	/* -------------------- */
	/* argument 4: start_column */

	/* -------------------- */
	l_status = smg$erase_chars
		(&l_display_id
		,&l_number_of_characters
		,&l_start_row
		,&l_start_column
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_erase_chars () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_ERASE_CHARS.C */
