/* VMS_SMG_FIND_CURSOR_DISPLAY.C -- 09-MAR-2000 Uwe Zessin
   Python interface to SMG$FIND_CURSOR_DISPLAY

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_FIND_CURSOR_DISPLAY

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_FIND_CURSOR_DISPLAY "20000309"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_find_cursor_dpy__doc[] =
"display_id = vms_smg.find_cursor_display\
 (pasteboard_id, [pasteboard_row], [pasteboard_column])\n\
Find Display that Contains the Cursor.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_find_cursor_display (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	unsigned long		  l_display_id;

	PyObject		* ar_pasteboard_row;
	unsigned long		  l_pasteboard_row;
	unsigned long		* al_pasteboard_row;

	PyObject		* ar_pasteboard_column;
	unsigned long		  l_pasteboard_column;
	unsigned long		* al_pasteboard_column;

	unsigned long		  l_status;

	/* -------------------- */
	ar_pasteboard_row    = Py_None;
	ar_pasteboard_column = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i|OO"
	    ,&l_pasteboard_id
	    ,&ar_pasteboard_row
	    ,&ar_pasteboard_column
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	/* argument 2: [pasteboard_row] */
	if (ar_pasteboard_row == Py_None)
	{
	    al_pasteboard_row = 0;		/* omitted */
	    l_pasteboard_row  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_pasteboard_row))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: pasteboard_row - must be integer or None");
		return NULL;
	    }
	    l_pasteboard_row = PyInt_AsLong(ar_pasteboard_row);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_pasteboard_row = &l_pasteboard_row;
	}

	/* -------------------- */
	/* argument 3: [pasteboard_column] */
	if (ar_pasteboard_column == Py_None)
	{
	    al_pasteboard_column = 0;		/* omitted */
	    l_pasteboard_column  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_pasteboard_column))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 3: pasteboard_column - must be integer or None");
		return NULL;
	    }
	    l_pasteboard_column = PyInt_AsLong(ar_pasteboard_column);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_pasteboard_column = &l_pasteboard_column;
	}

	/* -------------------- */
	l_status = smg$find_cursor_display
		(&l_pasteboard_id
		,&l_display_id
		,al_pasteboard_row
		,al_pasteboard_column
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    return Py_BuildValue ("i", l_display_id);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_find_cursor_display () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_FIND_CURSOR_DISPLAY.C */
