/* VMS_SMG_MOVE_VIRTUAL_DISPLAY.C -- 22-MAR-2000 Uwe Zessin
   Python interface to SMG$MOVE_VIRTUAL_DISPLAY

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_MOVE_VIRTUAL_DISPLAY

03-JUL-2000 ZE. -- return status code, because when pasteboard is batched
		'%SMG-S-BATWAS_ON, batching was on' is returned, which did
		raise an exception, before.
*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_MOVE_VIRTUAL_DISPLAY "20000703"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_move_virtual_dpy__doc[] =
"status = vms_smg.move_virtual_display\
 (display_id, pasteboard_id, pasteboard_row, pasteboard_column,\
 [top_display_id])\n\
Move Virtual Display.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_move_virtual_display (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	unsigned long		  l_pasteboard_id;
	long			  l_pasteboard_row;
	long			  l_pasteboard_column;

	PyObject		* ar_top_display_id;
	unsigned long		  l_top_display_id;
	unsigned long		* al_top_display_id;

	unsigned long		  l_status;

	/* -------------------- */
	ar_top_display_id = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "iiii|O"
	    ,&l_display_id
	    ,&l_pasteboard_id
	    ,&l_pasteboard_row
	    ,&l_pasteboard_column
	    ,&ar_top_display_id
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: pasteboard_id */

	/* -------------------- */
	/* argument 3: pasteboard_row */

	/* -------------------- */
	/* argument 4: pasteboard_column */

	/* -------------------- */
	/* argument 5: [top_display_id] */
	if (ar_top_display_id == Py_None)
	{
	    al_top_display_id = 0;		/* omitted */
	    l_top_display_id  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_top_display_id))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 5: top_display_id - must be integer or None");
		return NULL;
	    }
	    l_top_display_id = PyInt_AsLong(ar_top_display_id);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_top_display_id = &l_top_display_id;
	}

	/* -------------------- */
	l_status = smg$move_virtual_display
		(&l_display_id
		,&l_pasteboard_id
		,&l_pasteboard_row
		,&l_pasteboard_column
		,al_top_display_id
		);

	/* -------------------- */
	if ((l_status == SS$_NORMAL) || (l_status == SMG$_BATWAS_ON))
	{
	    return Py_BuildValue ("i", l_status);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_move_virtual_display () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_MOVE_VIRTUAL_DISPLAY.C */
