/* VMS_SMG_REMOVE_LINE.C -- 26-MAR-2000 Uwe Zessin
   Python interface to SMG$REMOVE_LINE

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_REMOVE_LINE

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_REMOVE_LINE "20000326"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <descrip.h>
#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_remove_line__doc[] =
"None = vms_smg.remove_line (display_id, start_row, start_column,\
 end_row, end_column)\n\
Remove a Line from a Virtual Display.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_remove_line (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	long			  l_start_row;
	long			  l_start_column;
	long			  l_end_row;
	long			  l_end_column;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "iiiii"
	    ,&l_display_id
	    ,&l_start_row
	    ,&l_start_column
	    ,&l_end_row
	    ,&l_end_column
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: start_row */

	/* -------------------- */
	/* argument 3: start_column */

	/* -------------------- */
	/* argument 4: end_row */

	/* -------------------- */
	/* argument 5: end_column */

	/* -------------------- */
	l_status = smg$remove_line
		(&l_display_id
		,&l_start_row
		,&l_start_column
		,&l_end_row
		,&l_end_column
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_remove_line () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_REMOVE_LINE.C */
