/* VMS_SMG_RING_BELL.C -- 01-APR-2000 Uwe Zessin
   Python interface to SMG$RING_BELL

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_RING_BELL

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_RING_BELL "20000401"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_ring_bell__doc[] =
"None = vms_smg.ring_bell (display_id, [number_of_times])\n\
Ring the Terminal Bell or Buzzer.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_ring_bell (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	PyObject		* ar_number_of_times;
	long			  l_number_of_times;
	long			* al_number_of_times;

	unsigned long		  l_status;

	/* -------------------- */
	ar_number_of_times  = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i|O"
	    ,&l_display_id
	    ,&ar_number_of_times
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: [number_of_times] */
	if (ar_number_of_times == Py_None)
	{
	    al_number_of_times = 0;		/* omitted */
	    l_number_of_times  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_number_of_times))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: number_of_times - must be integer or None");
		return NULL;
	    }
	    l_number_of_times = PyInt_AsLong(ar_number_of_times);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_number_of_times = &l_number_of_times;
	}

	/* -------------------- */
	l_status = smg$ring_bell
		(&l_display_id
		,al_number_of_times
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_ring_bell () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_RING_BELL.C */
