/* VMS_SMG_SCROLL_VIEWPORT.C -- 01-APR-2000 Uwe Zessin
   Python interface to SMG$SCROLL_VIEWPORT

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_SCROLL_VIEWPORT

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_SCROLL_VIEWPORT "20000401"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_scroll_viewport__doc[] =
"status = vms_smg.scroll_viewport (display_id, [direction], [count])\n\
Scroll a Display Under a Viewport.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_scroll_viewport (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	PyObject		* ar_direction;
	unsigned long		  l_direction;
	unsigned long		* al_direction;

	PyObject		* ar_count;
	long			  l_count;
	long			* al_count;

	unsigned long		  l_status;

	/* -------------------- */
	ar_direction    = Py_None;
	ar_count        = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i|OO"
	    ,&l_display_id
	    ,&ar_direction
	    ,&ar_count
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: [direction] */
	if (ar_direction == Py_None)
	{
	    al_direction = 0;		/* omitted */
	    l_direction  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_direction))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: direction - must be integer or None");
		return NULL;
	    }
	    l_direction = PyInt_AsLong(ar_direction);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_direction = &l_direction;
	}

	/* -------------------- */
	/* argument 3: [count] */
	if (ar_count == Py_None)
	{
	    al_count = 0;		/* omitted */
	    l_count  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_count))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 3: count - must be integer or None");
		return NULL;
	    }
	    l_count = PyInt_AsLong(ar_count);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_count = &l_count;
	}

	/* -------------------- */
	l_status = smg$scroll_viewport
		(&l_display_id
		,al_direction
		,al_count
		);

	/* -------------------- */
	return Py_BuildValue ("i", l_status);
} /* vms_smg_scroll_viewport () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_SCROLL_VIEWPORT.C */
