/* VMS_SMG_SET_DISPLAY_SCROLL_REGION.C -- 01-APR-2000 Uwe Zessin
   Python interface to SMG$SET_DISPLAY_SCROLL_REGION

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_SET_DISPLAY_SCROLL_REGION

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_SET_DISPLAY_SCROLL_RGN "20000401"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_set_dpy_scroll_rgn__doc[] =
"None = vms_smg.set_display_scroll_region\
 (display_id, [start_row], [end_row])\n\
Create Display Scrolling Region.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_set_display_scroll_rgn (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	PyObject		* ar_start_row;
	long			  l_start_row;
	long			* al_start_row;

	PyObject		* ar_end_row;
	long			  l_end_row;
	long			* al_end_row;

	unsigned long		  l_status;

	/* -------------------- */
	ar_start_row = Py_None;
	ar_end_row   = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i|OO"
	    ,&l_display_id
	    ,&ar_start_row
	    ,&ar_end_row
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: [start_row] */
	if (ar_start_row == Py_None)
	{
	    al_start_row = 0;		/* omitted */
	    l_start_row  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_start_row))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: start_row - must be integer or None");
		return NULL;
	    }
	    l_start_row = PyInt_AsLong(ar_start_row);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_start_row = &l_start_row;
	}

	/* -------------------- */
	/* argument 3: [end_row] */
	if (ar_end_row == Py_None)
	{
	    al_end_row = 0;		/* omitted */
	    l_end_row  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_end_row))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 3: end_row - must be integer or None");
		return NULL;
	    }
	    l_end_row = PyInt_AsLong(ar_end_row);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_end_row = &l_end_row;
	}

	/* -------------------- */
	l_status = smg$set_display_scroll_region
		(&l_display_id
		,al_start_row
		,al_end_row
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_set_display_scroll_rgn () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_SET_DISPLAY_SCROLL_REGION.C */
