/* VMS_SMG_SET_KEYPAD_MODE.C -- 01-APR-2000 Uwe Zessin
   Python interface to SMG$SET_KEYPAD_MODE

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_SET_KEYPAD_MODE

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_SET_KEYPAD_MODE "20000401"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_set_keypad_mode__doc[] =
"None = vms_smg.set_keypad_mode (keyboard_id, [flags])\n\
Set Keypad Mode.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_set_keypad_mode (PyObject *self, PyObject *args)
{
	unsigned long		  l_keyboard_id;
	unsigned long		  l_flags;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ii"
	    ,&l_keyboard_id
	    ,&l_flags
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: keyboard_id */

	/* -------------------- */
	/* argument 2: flags */

	/* -------------------- */
	l_status = smg$set_keypad_mode
		(&l_keyboard_id
		,&l_flags
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_set_keypad_mode () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_SET_KEYPAD_MODE.C */
