/* VMS_SYS_SUBSYSTEM.C -- 16-JAN-2000 Uwe Zessin
   Python interface to SYS$SUBSYSTEM()

??-???-???? ZE. -- created in VMS_SYS.C
16-JAN-2000 ZE. -- extract into VMS_SYS_SUBSYSTEM.C for V5.5-2 exclusion
*/

#ifdef __DECC
#pragma module VMS_SYS_SUBSYSTEM "20000116"
#endif

#include "python.h"
#include "vmsdef.h"

#include <descrip.h>
#include <ssdef.h>		/* SS$_name	 */
#include <starlet.h>		/* SYS$name, ... */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_sys_gr_error;	/* in VMS_SYS.C */
/* ------------------------------------------------------------------------- */

char vms_sys_subsystem__doc[] =
"oldflg = vms_sys.subsystem ([enbflg])\n\
Subsystem.";

PyObject *
vms_sys_subsystem (PyObject *self, PyObject *args)
{
	unsigned long	  l_enbflg;
	PyObject	* ar_enbflg;

	unsigned long	  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "O", &ar_enbflg))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: enbflg */
	if (ar_enbflg == Py_None)
	{
	    l_enbflg = 0;		/* save (disable) subsystem */
	}
	else
	{
	    if (!PyInt_Check(ar_enbflg))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 1: enbflg - must be integer or None");
		return NULL;
	    }
	    l_enbflg = PyInt_AsLong(ar_enbflg);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	}

	/* -------------------- */
	l_status = sys$subsystem (l_enbflg);

	/* -------------------- */
	if ((l_status == SS$_WASCLR) || (l_status == SS$_WASSET))
	{
	    if (l_status == SS$_WASCLR)
	    {
		l_enbflg = 0;
	    }
	    else
	    {
		l_enbflg = 1;
	    }
	    return PyInt_FromLong(l_enbflg);
	}

	/* -------------------- */
	/* error (according to the documentation this can't happen) */
	return PyVMS_ErrSetVal(vms_sys_gr_error, 1, l_status);
} /* vms_sys_subsystem () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SYS_SUBSYSTEM.C */
